SystemOrganization addCategory: #'Spec-Debugger'!

!PreDebugWindow methodsFor: '*spec-debugger' stamp: 'AndreiChis 12/13/2012 12:25'!
spawnSpecDebugger
	model spawnSpecDebugger! !

Debugger subclass: #SpecProxyDebugger
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Debugger'!

!SpecProxyDebugger commentStamp: '<historical>' prior: 0!
SpecProxyDebugger is a simple extension of the existing debugger that adds a button for opening the SpecDebugger in the pre-debugger window.

Instance Variables
!

!SpecProxyDebugger class methodsFor: 'class initialization' stamp: 'AndreiChis 12/13/2012 11:46'!
initialize
	super initialize.

	"Add ourselves to registry. See [Smalltalk tools]" 
	Smalltalk tools register: self as: #debugger! !

!SpecProxyDebugger methodsFor: 'accessing' stamp: 'AndreiChis 12/13/2012 11:46'!
debuggerClass
	^ SpecDebugger ! !

!SpecProxyDebugger methodsFor: 'initialize' stamp: 'AndreiChis 12/13/2012 12:26'!
preDebugButtonQuads
	| buttons |
	self isPostMortem 
		ifTrue: [ ^ self postMortemPreDebugButtonQuads ].
	^ {
		{'Proceed' translated.	#proceed. 	#blue. 	'Continue execution' translated}.
		{'Abandon' translated.	#abandon. 	#black.	'Abandon this execution by closing this window' translated}.
		{'Debug'    		translated.		#debug.		#red. 	'Bring up a debugger' translated}.
		{'Spec Debug' translated. #spawnSpecDebugger. #red. 'Bring up the Spec Debugger' translated}
	}! !

!SpecProxyDebugger methodsFor: 'notifier menu' stamp: 'AndreiChis 1/28/2013 11:36'!
spawnSpecDebugger
	| topView |
	topView := self topView.
	topView model: nil.
	"so close won't release me."
	self breakDependents.
	topView delete.
	
	self debuggerClass debugSession: ((self debuggerClass 
		spanNewSessionForContext: self interruptedContext fromProcess: self interruptedProcess)
			errorWasInUIProcess: errorWasInUIProcess) ! !

ComposableModel subclass: #SpecDebugger
	instanceVariableNames: 'session stack code toolbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Debugger'!

!SpecDebugger commentStamp: '<historical>' prior: 0!
A SpecDebugger a ui build in Spec that provides Smalltalk debugging functionality by using a DebugSession.

All the logic debugging is in DebugSession. SpecDebugger only provides an graphical interface to access that functionality.


Instance Variables
	code:		<Object>
	session:		<Object>
	stack:		<Object>
	toolbar:		<Object>

code
	- xxxxx

session
	- xxxxx

stack
	- xxxxx

toolbar
	- xxxxx
!

!SpecDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:22'!
debugContext: aContext fromProcess: aProcess

	^ self debugSession: (self spanNewSessionForContext: aContext fromProcess: aProcess)
! !

!SpecDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:22'!
debugProcess: aProcess

	^ self debugContext: aProcess suspendedContext fromProcess: aProcess! !

!SpecDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:35'!
debugSession: aSession

	<primitive: 19> "simulation guard"

	"WorldState addDeferredUIMessage: ["
		^ self openOn: aSession 
	"	]"
! !

!SpecDebugger class methodsFor: 'instance creation' stamp: 'AndreiChis 1/28/2013 16:27'!
openOn: aSession

	^ self new openOn: aSession ! !

!SpecDebugger class methodsFor: 'private' stamp: 'AndreiChis 1/7/2013 10:38'!
sessionClass

	^ DebugSession ! !

!SpecDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:29'!
spanNewSessionForContext: aContext fromProcess: aProcess

	^ self sessionClass process: aProcess context: aContext ! !

!SpecDebugger class methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 14:36'!
spanNewSessionForProcess: aProcess

	^ self spanNewSessionForContext: aProcess suspendedContext fromProcess: aProcess! !

!SpecDebugger class methodsFor: 'specs' stamp: 'AndreiChis 12/6/2012 16:34'!
spec
	<spec: #default>
	
	^ SpecLayout composed
		newColumn: [ :column | 
			column
				add: #stack;
				add: #toolbar height: 25;
				addSplitter;
				add: #code ]! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/29/2013 17:16'!
buildClassNameFor: aString
 	"shrink the name shown in the debugger "

	aString first = $[ 
			ifTrue: [  ^ '[...] in ', (aString splitOn: ' in ') last ].
	
	^ aString ! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/28/2013 10:58'!
close

	self removeActionsForSession: self session.
	self session terminate.
	 ! !

!SpecDebugger methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/7/2012 17:31'!
code

	^ code! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/29/2013 17:17'!
columnsFor: anEntry
	"Answer the array of contexts."

	| first second index stringRepresentation |
	stringRepresentation := anEntry printString.
	index := stringRepresentation findString: '>>'.
	first := stringRepresentation copyFrom: 1 to: index-1.
	second := stringRepresentation copyFrom: index+2 to: stringRepresentation size.
	^ {(self buildClassNameFor: first). second}! !

!SpecDebugger methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:00'!
context

	^ self session context! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 19:19'!
ensureBehavior

	self code behavior: self code behavior.
	"self code setSelection: (self session selectedCodeRange: self stack selectedItem) "! !

!SpecDebugger methodsFor: 'protocol' stamp: 'AndreiChis 1/31/2013 14:44'!
initialExtent 

	^  810@510! !

!SpecDebugger methodsFor: 'initialization' stamp: 'AndreiChis 1/28/2013 11:02'!
initialize

	session := nil asValueHolder.
	super initialize.
	
	session whenChangedDo: [:newSession :oldSession |
		self removeActionsForSession: oldSession.
		self registerActionsForSession: newSession.
		self updateToolbarFromSession: newSession.
		self updateStackFromSession: newSession ].! !

!SpecDebugger methodsFor: 'initialization' stamp: 'AndreiChis 1/31/2013 19:19'!
initializePresenter
	super initializePresenter.
	
	self stack whenListChanged: [
		self stack setSelectedItem: self context ].

	self stack whenSelectedItemChanged: [:aContext |
		self toolbar selectedContext: aContext.
		self updateCodeFromContext: aContext ]! !

!SpecDebugger methodsFor: 'initialization' stamp: 'AndreiChis 1/31/2013 16:47'!
initializeWidgets 

	self instantiateModels: {
		#stack -> #MultiColumnListModel. 
		#code -> #TextModel.
		#toolbar -> #SpecDebuggerToolbar }.

	self stack displayBlock: [:e | self columnsFor: e ].
	self code aboutToStyle: true.! !

!SpecDebugger methodsFor: 'protocol' stamp: 'AndreiChis 1/28/2013 16:25'!
openOn: aSession

	self 
		session: aSession; 
		openWithSpec;
		ensureBehavior! !

!SpecDebugger methodsFor: 'protocol' stamp: 'AndreiChis 12/6/2012 17:56'!
openWithSpec 

	| w |
	w := super openWithSpec.
	w whenClosedDo: [ self close ].
	^ w! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 14:41'!
registerActionsForSession: aSession

	aSession ifNotNil: [
		aSession
			when: #restart send: #updateRestart to: self;
			when: #resume send: #updateResume to: self;
			when: #stepInto send: #updateStepInto to: self;
			when: #stepOver send: #updateStepOver to: self;
			when: #stepThrough send: #updateStepThrough to: self;
			when: #contextChanged send: #updateContextChanged to: self  ]! !

!SpecDebugger methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 14:41'!
removeActionsForSession: aSession

	aSession ifNotNil: [ 
		aSession  
			removeActionsForEvent: #restart;
			removeActionsForEvent: #resume;
			removeActionsForEvent: #stepInto;
			removeActionsForEvent: #stepOver;
			removeActionsForEvent: #stepThrough;
			removeActionsForEvent:#contextChanged ]. ! !

!SpecDebugger methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:00'!
session

	^ session contents! !

!SpecDebugger methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:00'!
session: aSession

	session contents: aSession ! !

!SpecDebugger methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 21:05'!
stack

	^ stack! !

!SpecDebugger methodsFor: 'protocol' stamp: 'AndreiChis 12/6/2012 18:07'!
title

	^ 'Spec Debugger'! !

!SpecDebugger methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 21:05'!
toolbar

	^ toolbar! !

!SpecDebugger methodsFor: 'updating' stamp: 'AndreiChis 1/31/2013 19:18'!
updateCodeFromContext: aContext 

	aContext 
		ifNil: [
			self code 
				text: '';
				behavior: nil;
				readSelectionBlock: [ 1 to: 0 ] ]
		ifNotNil: [ |selectionInterval|
			self flag: 'Due to how TextModel>>setSelection: works it has to be done like this'.
			selectionInterval := self session selectedCodeRange: aContext.
			self code
				text: aContext sourceCode;
				behavior: aContext receiver class;
				readSelectionBlock: [ selectionInterval ] ]! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 1/31/2013 14:46'!
updateContextChanged

	self updateStep ! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 12/7/2012 17:27'!
updateRestart

	self updateStep 
	! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 12/7/2012 17:26'!
updateResume

	! !

!SpecDebugger methodsFor: 'updating' stamp: 'AndreiChis 1/28/2013 11:03'!
updateStackFromSession: aSession

	self stack items: aSession stack! !

!SpecDebugger methodsFor: 'updating' stamp: 'AndreiChis 1/28/2013 11:03'!
updateStep

	self updateStackFromSession: self session.
	
! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 12/6/2012 17:05'!
updateStepInto

	self updateStep ! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 12/6/2012 17:04'!
updateStepOver

	self updateStep 
	! !

!SpecDebugger methodsFor: 'updating actions' stamp: 'AndreiChis 12/7/2012 17:26'!
updateStepThrough

	self updateStep ! !

!SpecDebugger methodsFor: 'updating' stamp: 'AndreiChis 1/28/2013 11:04'!
updateToolbarFromSession: aSession

	self toolbar session: aSession.! !

ComposableModel subclass: #SpecDebuggerToolbar
	instanceVariableNames: 'session selectedContext resumeButton restartButton stepIntoButton stepOverButton stepThroughButton runToSelectionButton whereIsButton createMethodButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Spec-Debugger'!

!SpecDebuggerToolbar commentStamp: '<historical>' prior: 0!
SpecDebuggerToolbar maintains a list of buttons for the most important debugging actions. The execution of all actions is delegated to the session.

Instance Variables
	createMethodButton:		<Object>
	restartButton:		<Object>
	resumeButton:		<Object>
	runToSelectionButton:		<Object>
	selectedContext:		<Object>
	session:		<Object>
	stepIntoButton:		<Object>
	stepOverButton:		<Object>
	stepThroughButton:		<Object>
	whereIsButton:		<Object>

createMethodButton
	- xxxxx

restartButton
	- xxxxx

resumeButton
	- xxxxx

runToSelectionButton
	- xxxxx

selectedContext
	- xxxxx

session
	- xxxxx

stepIntoButton
	- xxxxx

stepOverButton
	- xxxxx

stepThroughButton
	- xxxxx

whereIsButton
	- xxxxx
!

!SpecDebuggerToolbar class methodsFor: 'specs' stamp: 'AndreiChis 1/31/2013 13:50'!
spec
	<spec>
	
	^ SpecLayout composed
		newRow: [ :r | 
			r
				add: #resumeButton;
				add: #restartButton;
				add: #stepIntoButton;
				add: #stepOverButton;
				add: #stepThroughButton;
				add: #runToSelectionButton;
				add: #whereIsButton;
				add: #createMethodButton ]! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/31/2013 13:46'!
createMethodAction

	self session createMethodInContext: self currentContext! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 1/31/2013 13:41'!
createMethodButton

	^ createMethodButton! !

!SpecDebuggerToolbar methodsFor: 'accessing' stamp: 'AndreiChis 1/31/2013 13:57'!
currentContext
	"I answer the context on which an action should be executed.
	This is either the selected context or if nothing is selected the interrupted context."
	
	^ self selectedContext isNil 
		ifTrue: [ self session context ]
		ifFalse: [ self selectedContext ]! !

!SpecDebuggerToolbar methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 15:31'!
debugger
	"Return the instance of the debugger containing this toolbar"
	
	^  owner! !

!SpecDebuggerToolbar methodsFor: 'initialization' stamp: 'AndreiChis 1/28/2013 11:07'!
initialize

	selectedContext := nil asValueHolder.
	session := nil asValueHolder.
	super initialize! !

!SpecDebuggerToolbar methodsFor: 'initialization' stamp: 'AndreiChis 1/31/2013 14:03'!
initializePresenter
	super initializePresenter.
	
	session whenChangedDo:  [
		self updateCreateMethodButton ].
	selectedContext  whenChangedDo: [:aContext |
		self updateCreateMethodButton ]! !

!SpecDebuggerToolbar methodsFor: 'initialization' stamp: 'AndreiChis 1/31/2013 13:55'!
initializeWidgets 

	self instantiateModels: {
		#resumeButton -> #ButtonModel.
		#restartButton -> #ButtonModel.
		#stepIntoButton -> #ButtonModel.
		#stepOverButton -> #ButtonModel.
		#stepThroughButton -> #ButtonModel.
		#runToSelectionButton -> #ButtonModel.
		#whereIsButton -> #ButtonModel.
		#createMethodButton -> #ButtonModel}.
		
	self resumeButton
		label: 'Proceed';
		state: false;
		action: [ self resumeAction ].
	self restartButton
		label: 'Restart';
		state: false;
		action: [ self restartAction ].
	self stepIntoButton
		label: 'Into';
		state: false;
		action: [ self stepIntoAction ].
	self stepOverButton
		label: 'Over';
		state: false;
		action: [ self stepOverAction ].
	self stepThroughButton  
		label: 'Through';
		state: false;
		action: [ self stepThroughAction ].
	self runToSelectionButton  
		label: 'Run to Here';
		state: false;
		action: [ self runToSelectionAction ].
	self whereIsButton  
		label: 'Where';
		state: false;
		action: [ self whereIsAction ].
	self createMethodButton  
		label: 'Create';
		state: false;
		enabled: self shouldEnableCreateMethodButton;
		action: [ self createMethodAction ].! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/28/2013 11:07'!
restartAction

	self session restart: self currentContext ! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 20:55'!
restartButton

	^ restartButton! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/28/2013 11:07'!
resumeAction

	self session 
		resume;
		clear.
	self window delete.! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 20:55'!
resumeButton

	^ resumeButton! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/31/2013 17:58'!
runToSelectionAction

	self session 
		runToSelection: self debugger code getSelection 
		inContext: self currentContext
! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 1/28/2013 11:57'!
runToSelectionButton

	^ runToSelectionButton! !

!SpecDebuggerToolbar methodsFor: 'accessing' stamp: 'AndreiChis 12/6/2012 16:39'!
selectedContext
	
	^ selectedContext contents ! !

!SpecDebuggerToolbar methodsFor: 'accessing' stamp: 'AndreiChis 12/6/2012 16:40'!
selectedContext: aContext
	
	selectedContext contents: aContext! !

!SpecDebuggerToolbar methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:06'!
session
	
	^ session contents ! !

!SpecDebuggerToolbar methodsFor: 'accessing' stamp: 'AndreiChis 1/28/2013 11:07'!
session: aSession
	
	session contents: aSession! !

!SpecDebuggerToolbar methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 15:34'!
shouldEnableCreateMethodButton

	^ self session 
		ifNil: [false]  
		ifNotNil: [:aSession |
			aSession isInterruptedContextDoesNotUnderstand and: [aSession context = self currentContext] ] ! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/28/2013 11:07'!
stepIntoAction

	self session stepInto: self currentContext ! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 20:55'!
stepIntoButton

	^ stepIntoButton! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/28/2013 11:07'!
stepOverAction

	self session stepOver: self currentContext ! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 20:56'!
stepOverButton

	^ stepOverButton ! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/28/2013 11:07'!
stepThroughAction

	self session stepThrough: self currentContext ! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 12/9/2012 20:56'!
stepThroughButton

	^ stepThroughButton ! !

!SpecDebuggerToolbar methodsFor: 'private' stamp: 'AndreiChis 1/31/2013 13:58'!
updateCreateMethodButton

	self createMethodButton enabled: self shouldEnableCreateMethodButton ! !

!SpecDebuggerToolbar methodsFor: 'actions' stamp: 'AndreiChis 1/31/2013 19:17'!
whereIsAction
	|selectionInterval|
	self flag: 'Due to how TextModel>>setSelection: works it has to be done like this'.
	selectionInterval := self session pcRangeForContext:  self currentContext.
	self debugger code readSelectionBlock: [selectionInterval]	
	! !

!SpecDebuggerToolbar methodsFor: 'accessing widgets' stamp: 'AndreiChis 1/28/2013 11:57'!
whereIsButton

	^ whereIsButton! !
SpecProxyDebugger initialize!
